/*
 * File:
 *    s3610LibTest.c
 *
 * Description:
 *    Test Vme SIS3610 interrupts with GEFANUC Linux Driver
 *    and SIS3610 library
 *
 *
 */


#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "jvme.h"
#include "sis3610.h"

int intMask=1;
unsigned int SIS_ADDR=0x3800;
unsigned int SIS_VEC=0xe1, SIS_LEVEL=5;

extern unsigned int s3610IntCount;
extern int s3610IntID;
extern struct s3610_struct *s3610p[];

/* Interrupt Service routine */
void
mytirISR(int arg)
{
  
  S3610_IRQ_DISABLE(s3610IntID);
  s3610IntCount++;

  /* Maybe... do something more useful here */
  s3610SetLED(0);
  s3610ClearLED(0);

  if(s3610IntCount%1==0)
    printf("Received %d triggers\n",s3610IntCount);

  /* Acknowledge the interrupt */
  s3610IntAck(intMask);

}


int 
main(int argc, char *argv[]) 
{

  int stat;

  printf("\nSIS3610 Library Tests \n");
  printf("----------------------------\n");

  vmeOpenDefaultWindows();

  /* Initialize the sis3610 */
  s3610Init(SIS_ADDR,0,0,0);

  s3610IntSet(0,SIS_LEVEL,SIS_VEC,1);

  stat = vmeIntConnect(SIS_VEC, SIS_LEVEL, mytirISR, 1);
  if (stat != OK) 
    {
      printf("ERROR: vmeIntConnect failed \n");
      goto CLOSE;
    } 
  else 
    {
      printf("INFO: Attached SIS3610 Interrupt\n");
    }
    
  s3610Status(0,0);

  printf("Hit any key to enable Interrupts...\n");
  getchar();

  /* Enable the s3610 and clear the trigger counter */
  s3610IntEnable(intMask);

  printf("Hit any key to Disable Interrupts and exit.\n");
  getchar();

  s3610IntDisable(intMask);

  stat = vmeIntDisconnect(SIS_LEVEL);
  if (stat != OK) 
    {
      printf("vmeIntDisconnect failed\n");
    }

 CLOSE:
  s3610Status(0,0);

  vmeCloseDefaultWindows();

  exit(0);
}

