/*
 * File:
 *    s3610SetOutput.c
 *
 * Description:
 *    Strobe output of specified channel to test control/flipflop input 1.
 *
 *
 */


#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "jvme.h"
#include "sis3610.h"

int 
main(int argc, char *argv[]) 
{

  int stat;

  printf("\nSIS3610 Library Tests \n");
  printf("----------------------------\n");

  vmeSetQuietFlag(1);
  
  if(vmeOpenDefaultWindows()!=OK)
    goto CLOSE;

  /* Initialize the sis3610 */
  if(s3610Init(0x3800,0,0,S3610_INIT_DAQ_MODE_POLLING)==ERROR)
    goto CLOSE;


  s3610IntSet(0, 5, 0xec, 1);
  
  s3610Status(0,0);

  s3610IntEnable(1);

  printf("s3610IntPoll = %d\n",s3610IntPoll(1));
  
  s3610WriteOutput(0, 1);

  printf("s3610IntPoll = %d\n",s3610IntPoll(1));
  
  s3610WriteOutput(0, 0);

  printf("s3610IntPoll = %d\n",s3610IntPoll(1));

  s3610IntAck(1);

  printf("s3610IntPoll = %d\n",s3610IntPoll(1));

  s3610IntDisable(1);

  s3610Status(0,0);
CLOSE:

  vmeCloseDefaultWindows();

  return 0;
}
